;
; fidentd 1.0.2 by triple
;
; contact:
;   #x-core @ EFnet
;   triple_irc@hotmail.com
;

alias fidentd {
  if ($dialog(fidentd)) dialog -v fidentd
  else dialog -m fidentd fidentd
}
alias -l fidentd.db return $shortfn($scriptdir) $+ fidentd.ini
alias -l fidentd.version return 1.0.2
alias -l fidentd.setDefaults {
  w.fidentd reply val nouser
  w.fidentd reply reply none
  w.fidentd reply status off
}
alias -l w.fidentd if ($3) writeini $fidentd.db $1 $2 $3-
alias -l r.fidentd if ($2) return $readini $fidentd.db $1 $2
alias -l fidentd.listen {
  if (!$portfree(113)) echo -ta [X] <- error: port 113 in use. please turn off any identd servers to use fidentd.
  else socklisten fidentd 113
}

dialog -l fidentd {
  title "fidentd 1.0.2"
  size -1 -1 100 84
  option dbu
  check "enabled", 1, 3 75 35 7
  box "reply type:", 2, 1 2 98 68
  radio "send reply", 3, 6 12 40 7
  edit "", 4, 46 10 50 11, autohs
  radio "unknown error", 5, 6 24 60 7
  radio "invalid port", 6, 6 36 60 7
  radio "no user", 7, 6 48 60 7
  button "ok", 8, 36 73 30 10, ok
  button "cancel", 9, 68 73 30 10, cancel
  radio "hidden user", 10, 6 60 60 7
}
on *:dialog:fidentd:*:*: {
  if ($devent == init) {
    if (!$r.fidentd(reply, status)) w.fidentd reply status off
    if (!$r.fidentd(reply, val)) w.fidentd reply val nouser
    if (!$r.fidentd(reply, reply)) w.fidentd reply reply none
    if ($r.fidentd(reply, status) == on) did -c $dname 1
    if ($r.fidentd(reply, reply)) did -a $dname 4 $ifmatch

    if ($r.fidentd(reply, val) == reply) did -c $dname 3
    else {
      did -b $dname 4
      if ($r.fidentd(reply, val) == unknownerror) did -c $dname 5
      elseif ($r.fidentd(reply, val) == invalidport) did -c $dname 6
      elseif ($r.fidentd(reply, val) == nouser) did -c $dname 7
      elseif ($r.fidentd(reply, val) == hiddenuser) did -c $dname 10
    }
  }
  if ($devent == sclick) {
    if ($istok(5 6 7 10, $did, 32)) did -b $dname 4
    if ($did == 3) did -e $dname 4
    if ($did == 8) {
      if ($did($dname, 1).state == 1) w.fidentd reply status on
      if ($did($dname, 1).state == 0) && ($sock(fidentd)) sockclose fidentd
      if ($did($dname, 1).state == 0) w.fidentd reply status off
      if ($did($dname, 3).state == 1) w.fidentd reply val reply
      if ($did($dname, 4)) && (!$regex($did($dname, 4), /^[a-zA-Z0-9\._-]+$/)) {
        ; strip those unaccepted characters and replace them with an underscore
        var %x, %i = $regsub($did($dname, 4), /[^a-zA-Z0-9\._-]/g, _, %x)
        did -ra $dname 4 %x
      }
      w.fidentd reply reply $iif($did($dname, 4), $ifmatch, none)
      if ($did($dname, 5).state == 1) w.fidentd reply val unknownerror
      if ($did($dname, 6).state == 1) w.fidentd reply val invalidport
      if ($did($dname, 7).state == 1) w.fidentd reply val nouser
      if ($did($dname, 10).state == 1) w.fidentd reply val hiddenuser
    }
  }
  if ($devent == close) && ($r.fidentd(reply, status) == on) && (!$sock(fidentd)) fidentd.listen
}

on *:start: {
  if (!$isfile($fidentd.db)) fidentd.setDefaults
  if ($r.fidentd(reply, status) == on) fidentd.listen
}

on *:socklisten:fidentd: {
  if ($sockerr) echo -ta [X] <- error: $sock($sockname).wsmsg
  else {
    echo -ta [!] <- fidentd request from $sock($sockname).ip
    sockaccept fidentd1
  }
}
on *:sockread:fidentd1: {
  if ($sockerr) echo -ta [X] <- error: $sock($sockname).wsmsg
  else {
    var %rply, %n
    sockread %n
    if ($sockbr > 0) {
      ; VERSION isn't specified in the RFC, but is taken on as a standard from other ident daemons
      if ($regex(%n, /^VERSION$/)) %rply = fidentd $fidentd.version for mIRC 6.0+
      elseif ($r.fidentd(reply, val) == nouser) %rply = %n : ERROR : NO-USER
      elseif ($r.fidentd(reply, val) == invalidport) %rply = %n : ERROR : INVALID-PORT
      elseif ($r.fidentd(reply, val) == unknownerror) %rply = %n : ERROR : UNKNOWN-ERROR
      elseif ($r.fidentd(reply, val) == hiddenuser) %rply = %n : ERROR : HIDDEN-USER
      elseif ($r.fidentd(reply, val) == reply) && ($r.fidentd(reply, reply)) %rply = %n : USERID : UNIX : $ifmatch
      sockwrite -n $sockname %rply
      echo -ta [!] -> fidentd reply: %rply
      sockclose $sockname
    }
  }
}

menu * {
  -
  fidentd 1.0.2: fidentd
}
